% demo of the Kstar Code

clear all;
close all;
clc;

%%
a = 3; b = 2; % parameters of the ellipse
nbPoints = 100; %number of points on the boundary
D = ellipse(a,b,nbPoints); % Definition of the ellipse

K = KD(D); % The operator K
% We can also construct the operator Ks = KDstar(D);
% Note that Ks is not the adjoint of K' : the sigma integration has already
% been taken into account into K and in Ks, so it loses the adjointness
% property.

% Check that [1]*(Ks-0.5) = 0.
fprintf('Check that (KD-0.5)[1] = 0. : %f\n\n', ...
    max(abs((K - 0.5*eye(nbPoints))*ones(nbPoints,1))));

S = svd(K); % The absolute values of the singular values of K

%% if a ~= b
% In theory, the singular values of K are 1/2 and 1/2 \pm [(a - b)/2/(a+b)]^n
e = (a-b)/(a+b);
n = 5;

Strue = zeros(2*n+1,1);
Strue(1) = 1/2;
for i=1:n
    Strue(2*i:2*i+1) = [e^i/2; e^i/2];
end

Snum = S(1:2*n+1);

fprintf('\nIn theory | Numerically');
[Strue, Snum]


%% GPT
lambda = 1;
PT = getGPT(D, lambda, 1, 1);
fprintf('The Polarization Tensor for lambda = %f is\n', lambda)
disp(PT)

%theoretical value for PT
k=(2*lambda+1)/(2*lambda-1);
PTtrue = pi*a*b*(k-1)*(a+b)*[1/(a+k*b), 0 ;  0, 1/(a*k+b)];
fprintf('The theoritical PT is\n')
disp(PTtrue)

%% PT for 2 inclusion

interpPoints=10;
theta = 2*pi*(0:interpPoints-1)/interpPoints;
nbPoints=20;

D1(1,:) = 0.5+0.5*cos(theta);
D1(2,:) = 0.0+0.5*sin(theta);

D2(1,:) = -0.8+0.3*cos(theta);
D2(2,:) = -0.5+0.3*sin(theta);

sp_D1 = splineCurve(D1, nbPoints);
sp_D2 = splineCurve(D2, nbPoints);

M_2incl=getPT_2incl(sp_D1,sp_D2,lambda);
M_2incl
